
% Default to the notebook output style

    


% Inherit from the specified cell style.




    
\documentclass[11pt]{article}

    
    
    \usepackage[T1]{fontenc}
    % Nicer default font (+ math font) than Computer Modern for most use cases
    \usepackage{mathpazo}

    % Basic figure setup, for now with no caption control since it's done
    % automatically by Pandoc (which extracts ![](path) syntax from Markdown).
    \usepackage{graphicx}
    % We will generate all images so they have a width \maxwidth. This means
    % that they will get their normal width if they fit onto the page, but
    % are scaled down if they would overflow the margins.
    \makeatletter
    \def\maxwidth{\ifdim\Gin@nat@width>\linewidth\linewidth
    \else\Gin@nat@width\fi}
    \makeatother
    \let\Oldincludegraphics\includegraphics
    % Set max figure width to be 80% of text width, for now hardcoded.
    \renewcommand{\includegraphics}[1]{\Oldincludegraphics[width=.8\maxwidth]{#1}}
    % Ensure that by default, figures have no caption (until we provide a
    % proper Figure object with a Caption API and a way to capture that
    % in the conversion process - todo).
    \usepackage{caption}
    \DeclareCaptionLabelFormat{nolabel}{}
    \captionsetup{labelformat=nolabel}

    \usepackage{adjustbox} % Used to constrain images to a maximum size 
    \usepackage{xcolor} % Allow colors to be defined
    \usepackage{enumerate} % Needed for markdown enumerations to work
    \usepackage{geometry} % Used to adjust the document margins
    \usepackage{amsmath} % Equations
    \usepackage{amssymb} % Equations
    \usepackage{textcomp} % defines textquotesingle
    % Hack from http://tex.stackexchange.com/a/47451/13684:
    \AtBeginDocument{%
        \def\PYZsq{\textquotesingle}% Upright quotes in Pygmentized code
    }
    \usepackage{upquote} % Upright quotes for verbatim code
    \usepackage{eurosym} % defines \euro
    \usepackage[mathletters]{ucs} % Extended unicode (utf-8) support
    \usepackage[utf8x]{inputenc} % Allow utf-8 characters in the tex document
    \usepackage{fancyvrb} % verbatim replacement that allows latex
    \usepackage{grffile} % extends the file name processing of package graphics 
                         % to support a larger range 
    % The hyperref package gives us a pdf with properly built
    % internal navigation ('pdf bookmarks' for the table of contents,
    % internal cross-reference links, web links for URLs, etc.)
    \usepackage{hyperref}
    \usepackage{longtable} % longtable support required by pandoc >1.10
    \usepackage{booktabs}  % table support for pandoc > 1.12.2
    \usepackage[inline]{enumitem} % IRkernel/repr support (it uses the enumerate* environment)
    \usepackage[normalem]{ulem} % ulem is needed to support strikethroughs (\sout)
                                % normalem makes italics be italics, not underlines
    

    
    
    % Colors for the hyperref package
    \definecolor{urlcolor}{rgb}{0,.145,.698}
    \definecolor{linkcolor}{rgb}{.71,0.21,0.01}
    \definecolor{citecolor}{rgb}{.12,.54,.11}

    % ANSI colors
    \definecolor{ansi-black}{HTML}{3E424D}
    \definecolor{ansi-black-intense}{HTML}{282C36}
    \definecolor{ansi-red}{HTML}{E75C58}
    \definecolor{ansi-red-intense}{HTML}{B22B31}
    \definecolor{ansi-green}{HTML}{00A250}
    \definecolor{ansi-green-intense}{HTML}{007427}
    \definecolor{ansi-yellow}{HTML}{DDB62B}
    \definecolor{ansi-yellow-intense}{HTML}{B27D12}
    \definecolor{ansi-blue}{HTML}{208FFB}
    \definecolor{ansi-blue-intense}{HTML}{0065CA}
    \definecolor{ansi-magenta}{HTML}{D160C4}
    \definecolor{ansi-magenta-intense}{HTML}{A03196}
    \definecolor{ansi-cyan}{HTML}{60C6C8}
    \definecolor{ansi-cyan-intense}{HTML}{258F8F}
    \definecolor{ansi-white}{HTML}{C5C1B4}
    \definecolor{ansi-white-intense}{HTML}{A1A6B2}

    % commands and environments needed by pandoc snippets
    % extracted from the output of `pandoc -s`
    \providecommand{\tightlist}{%
      \setlength{\itemsep}{0pt}\setlength{\parskip}{0pt}}
    \DefineVerbatimEnvironment{Highlighting}{Verbatim}{commandchars=\\\{\}}
    % Add ',fontsize=\small' for more characters per line
    \newenvironment{Shaded}{}{}
    \newcommand{\KeywordTok}[1]{\textcolor[rgb]{0.00,0.44,0.13}{\textbf{{#1}}}}
    \newcommand{\DataTypeTok}[1]{\textcolor[rgb]{0.56,0.13,0.00}{{#1}}}
    \newcommand{\DecValTok}[1]{\textcolor[rgb]{0.25,0.63,0.44}{{#1}}}
    \newcommand{\BaseNTok}[1]{\textcolor[rgb]{0.25,0.63,0.44}{{#1}}}
    \newcommand{\FloatTok}[1]{\textcolor[rgb]{0.25,0.63,0.44}{{#1}}}
    \newcommand{\CharTok}[1]{\textcolor[rgb]{0.25,0.44,0.63}{{#1}}}
    \newcommand{\StringTok}[1]{\textcolor[rgb]{0.25,0.44,0.63}{{#1}}}
    \newcommand{\CommentTok}[1]{\textcolor[rgb]{0.38,0.63,0.69}{\textit{{#1}}}}
    \newcommand{\OtherTok}[1]{\textcolor[rgb]{0.00,0.44,0.13}{{#1}}}
    \newcommand{\AlertTok}[1]{\textcolor[rgb]{1.00,0.00,0.00}{\textbf{{#1}}}}
    \newcommand{\FunctionTok}[1]{\textcolor[rgb]{0.02,0.16,0.49}{{#1}}}
    \newcommand{\RegionMarkerTok}[1]{{#1}}
    \newcommand{\ErrorTok}[1]{\textcolor[rgb]{1.00,0.00,0.00}{\textbf{{#1}}}}
    \newcommand{\NormalTok}[1]{{#1}}
    
    % Additional commands for more recent versions of Pandoc
    \newcommand{\ConstantTok}[1]{\textcolor[rgb]{0.53,0.00,0.00}{{#1}}}
    \newcommand{\SpecialCharTok}[1]{\textcolor[rgb]{0.25,0.44,0.63}{{#1}}}
    \newcommand{\VerbatimStringTok}[1]{\textcolor[rgb]{0.25,0.44,0.63}{{#1}}}
    \newcommand{\SpecialStringTok}[1]{\textcolor[rgb]{0.73,0.40,0.53}{{#1}}}
    \newcommand{\ImportTok}[1]{{#1}}
    \newcommand{\DocumentationTok}[1]{\textcolor[rgb]{0.73,0.13,0.13}{\textit{{#1}}}}
    \newcommand{\AnnotationTok}[1]{\textcolor[rgb]{0.38,0.63,0.69}{\textbf{\textit{{#1}}}}}
    \newcommand{\CommentVarTok}[1]{\textcolor[rgb]{0.38,0.63,0.69}{\textbf{\textit{{#1}}}}}
    \newcommand{\VariableTok}[1]{\textcolor[rgb]{0.10,0.09,0.49}{{#1}}}
    \newcommand{\ControlFlowTok}[1]{\textcolor[rgb]{0.00,0.44,0.13}{\textbf{{#1}}}}
    \newcommand{\OperatorTok}[1]{\textcolor[rgb]{0.40,0.40,0.40}{{#1}}}
    \newcommand{\BuiltInTok}[1]{{#1}}
    \newcommand{\ExtensionTok}[1]{{#1}}
    \newcommand{\PreprocessorTok}[1]{\textcolor[rgb]{0.74,0.48,0.00}{{#1}}}
    \newcommand{\AttributeTok}[1]{\textcolor[rgb]{0.49,0.56,0.16}{{#1}}}
    \newcommand{\InformationTok}[1]{\textcolor[rgb]{0.38,0.63,0.69}{\textbf{\textit{{#1}}}}}
    \newcommand{\WarningTok}[1]{\textcolor[rgb]{0.38,0.63,0.69}{\textbf{\textit{{#1}}}}}
    
    
    % Define a nice break command that doesn't care if a line doesn't already
    % exist.
    \def\br{\hspace*{\fill} \\* }
    % Math Jax compatability definitions
    \def\gt{>}
    \def\lt{<}
    % Document parameters
    \title{AzureSearch\_Walkthrough}
    
    
    

    % Pygments definitions
    
\makeatletter
\def\PY@reset{\let\PY@it=\relax \let\PY@bf=\relax%
    \let\PY@ul=\relax \let\PY@tc=\relax%
    \let\PY@bc=\relax \let\PY@ff=\relax}
\def\PY@tok#1{\csname PY@tok@#1\endcsname}
\def\PY@toks#1+{\ifx\relax#1\empty\else%
    \PY@tok{#1}\expandafter\PY@toks\fi}
\def\PY@do#1{\PY@bc{\PY@tc{\PY@ul{%
    \PY@it{\PY@bf{\PY@ff{#1}}}}}}}
\def\PY#1#2{\PY@reset\PY@toks#1+\relax+\PY@do{#2}}

\expandafter\def\csname PY@tok@w\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.73,0.73}{##1}}}
\expandafter\def\csname PY@tok@c\endcsname{\let\PY@it=\textit\def\PY@tc##1{\textcolor[rgb]{0.25,0.50,0.50}{##1}}}
\expandafter\def\csname PY@tok@cp\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.74,0.48,0.00}{##1}}}
\expandafter\def\csname PY@tok@k\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@kp\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@kt\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.69,0.00,0.25}{##1}}}
\expandafter\def\csname PY@tok@o\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.40,0.40,0.40}{##1}}}
\expandafter\def\csname PY@tok@ow\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.67,0.13,1.00}{##1}}}
\expandafter\def\csname PY@tok@nb\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@nf\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.00,0.00,1.00}{##1}}}
\expandafter\def\csname PY@tok@nc\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.00,1.00}{##1}}}
\expandafter\def\csname PY@tok@nn\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.00,1.00}{##1}}}
\expandafter\def\csname PY@tok@ne\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.82,0.25,0.23}{##1}}}
\expandafter\def\csname PY@tok@nv\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.10,0.09,0.49}{##1}}}
\expandafter\def\csname PY@tok@no\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.53,0.00,0.00}{##1}}}
\expandafter\def\csname PY@tok@nl\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.63,0.63,0.00}{##1}}}
\expandafter\def\csname PY@tok@ni\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.60,0.60,0.60}{##1}}}
\expandafter\def\csname PY@tok@na\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.49,0.56,0.16}{##1}}}
\expandafter\def\csname PY@tok@nt\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@nd\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.67,0.13,1.00}{##1}}}
\expandafter\def\csname PY@tok@s\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@sd\endcsname{\let\PY@it=\textit\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@si\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.73,0.40,0.53}{##1}}}
\expandafter\def\csname PY@tok@se\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.73,0.40,0.13}{##1}}}
\expandafter\def\csname PY@tok@sr\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.40,0.53}{##1}}}
\expandafter\def\csname PY@tok@ss\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.10,0.09,0.49}{##1}}}
\expandafter\def\csname PY@tok@sx\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@m\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.40,0.40,0.40}{##1}}}
\expandafter\def\csname PY@tok@gh\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.00,0.50}{##1}}}
\expandafter\def\csname PY@tok@gu\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.50,0.00,0.50}{##1}}}
\expandafter\def\csname PY@tok@gd\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.63,0.00,0.00}{##1}}}
\expandafter\def\csname PY@tok@gi\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.00,0.63,0.00}{##1}}}
\expandafter\def\csname PY@tok@gr\endcsname{\def\PY@tc##1{\textcolor[rgb]{1.00,0.00,0.00}{##1}}}
\expandafter\def\csname PY@tok@ge\endcsname{\let\PY@it=\textit}
\expandafter\def\csname PY@tok@gs\endcsname{\let\PY@bf=\textbf}
\expandafter\def\csname PY@tok@gp\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.00,0.50}{##1}}}
\expandafter\def\csname PY@tok@go\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.53,0.53,0.53}{##1}}}
\expandafter\def\csname PY@tok@gt\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.00,0.27,0.87}{##1}}}
\expandafter\def\csname PY@tok@err\endcsname{\def\PY@bc##1{\setlength{\fboxsep}{0pt}\fcolorbox[rgb]{1.00,0.00,0.00}{1,1,1}{\strut ##1}}}
\expandafter\def\csname PY@tok@kc\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@kd\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@kn\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@kr\endcsname{\let\PY@bf=\textbf\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@bp\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.00,0.50,0.00}{##1}}}
\expandafter\def\csname PY@tok@fm\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.00,0.00,1.00}{##1}}}
\expandafter\def\csname PY@tok@vc\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.10,0.09,0.49}{##1}}}
\expandafter\def\csname PY@tok@vg\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.10,0.09,0.49}{##1}}}
\expandafter\def\csname PY@tok@vi\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.10,0.09,0.49}{##1}}}
\expandafter\def\csname PY@tok@vm\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.10,0.09,0.49}{##1}}}
\expandafter\def\csname PY@tok@sa\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@sb\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@sc\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@dl\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@s2\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@sh\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@s1\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.73,0.13,0.13}{##1}}}
\expandafter\def\csname PY@tok@mb\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.40,0.40,0.40}{##1}}}
\expandafter\def\csname PY@tok@mf\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.40,0.40,0.40}{##1}}}
\expandafter\def\csname PY@tok@mh\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.40,0.40,0.40}{##1}}}
\expandafter\def\csname PY@tok@mi\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.40,0.40,0.40}{##1}}}
\expandafter\def\csname PY@tok@il\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.40,0.40,0.40}{##1}}}
\expandafter\def\csname PY@tok@mo\endcsname{\def\PY@tc##1{\textcolor[rgb]{0.40,0.40,0.40}{##1}}}
\expandafter\def\csname PY@tok@ch\endcsname{\let\PY@it=\textit\def\PY@tc##1{\textcolor[rgb]{0.25,0.50,0.50}{##1}}}
\expandafter\def\csname PY@tok@cm\endcsname{\let\PY@it=\textit\def\PY@tc##1{\textcolor[rgb]{0.25,0.50,0.50}{##1}}}
\expandafter\def\csname PY@tok@cpf\endcsname{\let\PY@it=\textit\def\PY@tc##1{\textcolor[rgb]{0.25,0.50,0.50}{##1}}}
\expandafter\def\csname PY@tok@c1\endcsname{\let\PY@it=\textit\def\PY@tc##1{\textcolor[rgb]{0.25,0.50,0.50}{##1}}}
\expandafter\def\csname PY@tok@cs\endcsname{\let\PY@it=\textit\def\PY@tc##1{\textcolor[rgb]{0.25,0.50,0.50}{##1}}}

\def\PYZbs{\char`\\}
\def\PYZus{\char`\_}
\def\PYZob{\char`\{}
\def\PYZcb{\char`\}}
\def\PYZca{\char`\^}
\def\PYZam{\char`\&}
\def\PYZlt{\char`\<}
\def\PYZgt{\char`\>}
\def\PYZsh{\char`\#}
\def\PYZpc{\char`\%}
\def\PYZdl{\char`\$}
\def\PYZhy{\char`\-}
\def\PYZsq{\char`\'}
\def\PYZdq{\char`\"}
\def\PYZti{\char`\~}
% for compatibility with earlier versions
\def\PYZat{@}
\def\PYZlb{[}
\def\PYZrb{]}
\makeatother


    % Exact colors from NB
    \definecolor{incolor}{rgb}{0.0, 0.0, 0.5}
    \definecolor{outcolor}{rgb}{0.545, 0.0, 0.0}



    
    % Prevent overflowing lines due to hard-to-break entities
    \sloppy 
    % Setup hyperref package
    \hypersetup{
      breaklinks=true,  % so long urls are correctly broken across lines
      colorlinks=true,
      urlcolor=urlcolor,
      linkcolor=linkcolor,
      citecolor=citecolor,
      }
    % Slightly bigger margins than the latex defaults
    
    \geometry{verbose,tmargin=1in,bmargin=1in,lmargin=1in,rmargin=1in}
    
    

    \begin{document}
    
    
    \maketitle
    
    

    
    \hypertarget{azure-search-demo}{%
\section{Azure Search Demo}\label{azure-search-demo}}

This notebook will walk you through the basics of interacting with Azure
Search via the REST API. We will:

\begin{enumerate}
\def\labelenumi{\arabic{enumi}.}
\tightlist
\item
  Create a new index\\
\item
  Delete an index
\item
  Upload documents to our new index\\
\item
  Search the documents
\end{enumerate}

To execute the code, you will need a valid API key and Service name.

\hypertarget{azure-demo-code}{%
\subsection{Azure Demo Code}\label{azure-demo-code}}

We'll begin with a little housekeeping, we've created a class,
AzureSearchDemo, which holds all of the logic to interface with Azure
Search. I've left the definition of this class here, in this notebook,
so that you have everything you need in one place :)

    \begin{Verbatim}[commandchars=\\\{\}]
{\color{incolor}In [{\color{incolor}1}]:} \PY{k+kn}{import} \PY{n+nn}{requests}
        \PY{k+kn}{import} \PY{n+nn}{httplib2}
        \PY{k+kn}{import} \PY{n+nn}{pandas} \PY{k}{as} \PY{n+nn}{pd}
        \PY{k+kn}{import} \PY{n+nn}{json}
        
        \PY{k}{class} \PY{n+nc}{AzureSearchDemo}\PY{p}{:}
            
            \PY{l+s+sd}{\PYZdq{}\PYZdq{}\PYZdq{}}
        \PY{l+s+sd}{    Example class to interact with AzureSearch.}
        \PY{l+s+sd}{    }
        \PY{l+s+sd}{    Requires a secrets file (csv) with the following entries:}
        \PY{l+s+sd}{        \PYZob{}}
        \PY{l+s+sd}{            ID: [1, 2, 3], }
        \PY{l+s+sd}{            Description: [\PYZdq{}AdminKey\PYZdq{}, \PYZdq{}SearchKey\PYZdq{}, \PYZdq{}ServiceName\PYZdq{}], }
        \PY{l+s+sd}{            Key: [your\PYZus{}keys\PYZus{}here]}
        \PY{l+s+sd}{        \PYZcb{}}
        \PY{l+s+sd}{        }
        \PY{l+s+sd}{    \PYZdq{}\PYZdq{}\PYZdq{}}
            \PY{k}{def} \PY{n+nf}{\PYZus{}\PYZus{}init\PYZus{}\PYZus{}}\PY{p}{(}\PY{n+nb+bp}{self}\PY{p}{,} \PY{n}{secrets\PYZus{}file} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{./secrets.csv}\PY{l+s+s2}{\PYZdq{}}\PY{p}{)}\PY{p}{:}
                \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{secrets\PYZus{}file} \PY{o}{=} \PY{n}{secrets\PYZus{}file}
                \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{read\PYZus{}secrets}\PY{p}{(}\PY{p}{)}
                \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{header} \PY{o}{=} \PY{p}{\PYZob{}}
                    \PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{Content\PYZhy{}Type}\PY{l+s+s1}{\PYZsq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{application/json; charset=UTF\PYZhy{}8}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,}
                    \PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{Api\PYZhy{}Key}\PY{l+s+s1}{\PYZsq{}}\PY{p}{:} \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{admin\PYZus{}key}\PY{p}{,}
                    \PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{Accept}\PY{l+s+s1}{\PYZsq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{application/json}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{Accept\PYZhy{}Charset}\PY{l+s+s1}{\PYZsq{}}\PY{p}{:}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{UTF\PYZhy{}8}\PY{l+s+s2}{\PYZdq{}}
                \PY{p}{\PYZcb{}}
                \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{conn} \PY{o}{=} \PY{n}{httplib2}\PY{o}{.}\PY{n}{Http}\PY{p}{(}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{.cache}\PY{l+s+s2}{\PYZdq{}}\PY{p}{)}
            
            \PY{k}{def} \PY{n+nf}{read\PYZus{}secrets}\PY{p}{(}\PY{n+nb+bp}{self}\PY{p}{)}\PY{p}{:}
                \PY{n}{secrets} \PY{o}{=} \PY{n}{pd}\PY{o}{.}\PY{n}{read\PYZus{}csv}\PY{p}{(}\PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{secrets\PYZus{}file}\PY{p}{)}
                \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{admin\PYZus{}key} \PY{o}{=} \PY{n}{secrets}\PY{p}{[}\PY{n}{secrets}\PY{p}{[}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Description}\PY{l+s+s2}{\PYZdq{}}\PY{p}{]} \PY{o}{==} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{AdminKey}\PY{l+s+s2}{\PYZdq{}}\PY{p}{]}\PY{p}{[}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Key}\PY{l+s+s2}{\PYZdq{}}\PY{p}{]}\PY{o}{.}\PY{n}{values}\PY{p}{[}\PY{l+m+mi}{0}\PY{p}{]}
                \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{search\PYZus{}key} \PY{o}{=} \PY{n}{secrets}\PY{p}{[}\PY{n}{secrets}\PY{p}{[}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Description}\PY{l+s+s2}{\PYZdq{}}\PY{p}{]} \PY{o}{==} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{SearchKey}\PY{l+s+s2}{\PYZdq{}}\PY{p}{]}\PY{p}{[}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Key}\PY{l+s+s2}{\PYZdq{}}\PY{p}{]}\PY{o}{.}\PY{n}{values}\PY{p}{[}\PY{l+m+mi}{0}\PY{p}{]}
                \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{service\PYZus{}name} \PY{o}{=} \PY{n}{secrets}\PY{p}{[}\PY{n}{secrets}\PY{p}{[}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Description}\PY{l+s+s2}{\PYZdq{}}\PY{p}{]} \PY{o}{==} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{ServiceName}\PY{l+s+s2}{\PYZdq{}}\PY{p}{]}\PY{p}{[}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Key}\PY{l+s+s2}{\PYZdq{}}\PY{p}{]}\PY{o}{.}\PY{n}{values}\PY{p}{[}\PY{l+m+mi}{0}\PY{p}{]}
                
                \PY{k}{return}        
                
                
            \PY{k}{def} \PY{n+nf}{paste\PYZus{}url}\PY{p}{(}\PY{n+nb+bp}{self}\PY{p}{,} \PY{n}{method} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{create}\PY{l+s+s2}{\PYZdq{}}\PY{p}{)}\PY{p}{:}
                \PY{l+s+sd}{\PYZdq{}\PYZdq{}\PYZdq{}}
        \PY{l+s+sd}{        Creates the URL. }
        \PY{l+s+sd}{        }
        \PY{l+s+sd}{        Method (string) creats, delete or upload}
        \PY{l+s+sd}{            create: url to create a new index}
        \PY{l+s+sd}{            delete: url to delete an existing index}
        \PY{l+s+sd}{            upload: url to upload new documents to an index}
        \PY{l+s+sd}{        \PYZdq{}\PYZdq{}\PYZdq{}}
                
                \PY{k}{if} \PY{n}{method} \PY{o}{==} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{create}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:}
                    \PY{n}{url} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{https://}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{.search.windows.net/indexes?api\PYZhy{}version=2017\PYZhy{}11\PYZhy{}11}\PY{l+s+s2}{\PYZdq{}}\PY{o}{.}\PY{n}{format}\PY{p}{(}\PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{service\PYZus{}name}\PY{p}{)}
                \PY{k}{elif} \PY{n}{method} \PY{o}{==} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{delete}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:}
                    \PY{n}{url} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{https://}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{.search.windows.net/indexes/}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{?api\PYZhy{}version=2017\PYZhy{}11\PYZhy{}11}\PY{l+s+s2}{\PYZdq{}}\PY{o}{.}\PY{n}{format}\PY{p}{(}\PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{service\PYZus{}name}\PY{p}{,}
                                                                                                   \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{index\PYZus{}name}\PY{p}{)}
                \PY{k}{elif} \PY{n}{method} \PY{o}{==} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{query}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:}
                    \PY{n}{url} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{https://}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{.search.windows.net/indexes/}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{/docs?api\PYZhy{}version=2017\PYZhy{}11\PYZhy{}11\PYZam{}}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{\PYZdq{}}\PY{o}{.}\PY{n}{format}\PY{p}{(}\PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{service\PYZus{}name}\PY{p}{,}
                                                                                                   \PY{n}{index\PYZus{}name}\PY{p}{,}
                                                                                                   \PY{n}{params}\PY{p}{)}
                \PY{k}{else}\PY{p}{:}
                    \PY{n}{url} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{https://}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{.search.windows.net/indexes/}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{/docs/index?api\PYZhy{}version=2017\PYZhy{}11\PYZhy{}11}\PY{l+s+s2}{\PYZdq{}}\PY{o}{.}\PY{n}{format}\PY{p}{(}\PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{service\PYZus{}name}\PY{p}{,}
                                                                                                              \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{index\PYZus{}name}\PY{p}{)}
                \PY{k}{return} \PY{n}{url}
            
            \PY{k}{def} \PY{n+nf}{create\PYZus{}index}\PY{p}{(}\PY{n+nb+bp}{self}\PY{p}{,} \PY{n}{schema}\PY{p}{)}\PY{p}{:}
                \PY{l+s+sd}{\PYZdq{}\PYZdq{}\PYZdq{}}
        \PY{l+s+sd}{        Creates a new index. Requires JSON\PYZhy{}formatted schema. }
        \PY{l+s+sd}{        }
        \PY{l+s+sd}{        Tips:}
        \PY{l+s+sd}{        }
        \PY{l+s+sd}{          \PYZhy{} The index name must be all lowercase}
        \PY{l+s+sd}{          \PYZhy{} The unique key must be a string}
        \PY{l+s+sd}{        }
        \PY{l+s+sd}{        See documentation: https://docs.microsoft.com/en\PYZhy{}us/rest/api/searchservice/Create\PYZhy{}Index}
        \PY{l+s+sd}{        \PYZdq{}\PYZdq{}\PYZdq{}}
                \PY{n}{response}\PY{p}{,} \PY{n}{content} \PY{o}{=} \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{conn}\PY{o}{.}\PY{n}{request}\PY{p}{(}\PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{paste\PYZus{}url}\PY{p}{(}\PY{p}{)}\PY{p}{,} \PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{POST}\PY{l+s+s1}{\PYZsq{}}\PY{p}{,} \PY{n}{headers} \PY{o}{=} \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{header}\PY{p}{,} \PY{n}{body} \PY{o}{=} \PY{n}{json}\PY{o}{.}\PY{n}{dumps}\PY{p}{(}\PY{n}{schema}\PY{p}{)}\PY{p}{)}
                
                \PY{k}{if} \PY{n}{response}\PY{o}{.}\PY{n}{status} \PY{o}{!=} \PY{l+m+mi}{201}\PY{p}{:}
                    \PY{n+nb}{print}\PY{p}{(}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{There was an error creating index: }\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{\PYZdq{}}\PY{o}{.}\PY{n}{format}\PY{p}{(}\PY{n}{schema}\PY{p}{[}\PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{name}\PY{l+s+s1}{\PYZsq{}}\PY{p}{]}\PY{p}{)}\PY{p}{)}
                    \PY{n+nb}{print}\PY{p}{(}\PY{n}{json}\PY{o}{.}\PY{n}{loads}\PY{p}{(}\PY{n}{content}\PY{p}{)}\PY{p}{)}
                    
                \PY{k}{else}\PY{p}{:}
                    \PY{n+nb}{print}\PY{p}{(}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Index,  }\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{, created successfully.}\PY{l+s+s2}{\PYZdq{}}\PY{o}{.}\PY{n}{format}\PY{p}{(}\PY{n}{schema}\PY{p}{[}\PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{name}\PY{l+s+s1}{\PYZsq{}}\PY{p}{]}\PY{p}{)}\PY{p}{)}
                    
                \PY{k}{return} \PY{p}{(}\PY{n}{response}\PY{p}{,} \PY{n}{content}\PY{p}{)}
            
            \PY{k}{def} \PY{n+nf}{delete\PYZus{}index}\PY{p}{(}\PY{n+nb+bp}{self}\PY{p}{,} \PY{n}{index\PYZus{}name}\PY{p}{)}\PY{p}{:}
                \PY{l+s+sd}{\PYZdq{}\PYZdq{}\PYZdq{}Deletes an index\PYZdq{}\PYZdq{}\PYZdq{}}
                \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{index\PYZus{}name} \PY{o}{=} \PY{n}{index\PYZus{}name}
                \PY{n}{response}\PY{p}{,} \PY{n}{content} \PY{o}{=} \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{conn}\PY{o}{.}\PY{n}{request}\PY{p}{(}\PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{paste\PYZus{}url}\PY{p}{(}\PY{n}{method} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{delete}\PY{l+s+s2}{\PYZdq{}}\PY{p}{)}\PY{p}{,} \PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{DELETE}\PY{l+s+s1}{\PYZsq{}}\PY{p}{,} \PY{n}{headers} \PY{o}{=} \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{header}\PY{p}{)}
                
                \PY{k}{return} \PY{p}{(}\PY{n}{response}\PY{p}{,} \PY{n}{content}\PY{p}{)}
            
            \PY{k}{def} \PY{n+nf}{upload\PYZus{}documents}\PY{p}{(}\PY{n+nb+bp}{self}\PY{p}{,} \PY{n}{index\PYZus{}name}\PY{p}{,} \PY{n}{documents}\PY{p}{,} \PY{n}{docformat} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{dataframe}\PY{l+s+s2}{\PYZdq{}}\PY{p}{)}\PY{p}{:}
                \PY{l+s+sd}{\PYZdq{}\PYZdq{}\PYZdq{}}
        \PY{l+s+sd}{        Uploads documents}
        \PY{l+s+sd}{        }
        \PY{l+s+sd}{        Assumes documents are a dataframe and then formats then appropriately}
        \PY{l+s+sd}{        as per the documentation: https://docs.microsoft.com/en\PYZhy{}us/azure/search/search\PYZhy{}import\PYZhy{}data\PYZhy{}rest\PYZhy{}api}
        \PY{l+s+sd}{        \PYZdq{}\PYZdq{}\PYZdq{}}
                \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{index\PYZus{}name} \PY{o}{=} \PY{n}{index\PYZus{}name}
                \PY{n}{payload} \PY{o}{=} \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{format\PYZus{}documents}\PY{p}{(}\PY{n}{documents}\PY{p}{)}
                \PY{n}{response}\PY{p}{,} \PY{n}{content} \PY{o}{=} \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{conn}\PY{o}{.}\PY{n}{request}\PY{p}{(}\PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{paste\PYZus{}url}\PY{p}{(}\PY{n}{method} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{url}\PY{l+s+s2}{\PYZdq{}}\PY{p}{)}\PY{p}{,} 
                                                      \PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{POST}\PY{l+s+s1}{\PYZsq{}}\PY{p}{,} 
                                                      \PY{n}{headers} \PY{o}{=} \PY{n+nb+bp}{self}\PY{o}{.}\PY{n}{header}\PY{p}{,} \PY{n}{body}\PY{o}{=}\PY{n}{json}\PY{o}{.}\PY{n}{dumps}\PY{p}{(}\PY{n}{payload}\PY{p}{)}\PY{p}{)}
                
                \PY{k}{return} \PY{p}{(}\PY{n}{response}\PY{p}{,} \PY{n}{content}\PY{p}{)}
            
            \PY{k}{def} \PY{n+nf}{format\PYZus{}documents}\PY{p}{(}\PY{n+nb+bp}{self}\PY{p}{,} \PY{n}{documents}\PY{p}{)}\PY{p}{:}
                \PY{l+s+sd}{\PYZdq{}\PYZdq{}\PYZdq{}}
        \PY{l+s+sd}{        Given a data frame of documents, parse into properly formatted json}
        \PY{l+s+sd}{        \PYZdq{}\PYZdq{}\PYZdq{}}
                \PY{n}{documents}\PY{p}{[}\PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{@search.action}\PY{l+s+s1}{\PYZsq{}}\PY{p}{]} \PY{o}{=} \PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{upload}\PY{l+s+s1}{\PYZsq{}}
                \PY{n}{payload} \PY{o}{=} \PY{p}{\PYZob{}}
                    \PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{value}\PY{l+s+s1}{\PYZsq{}}\PY{p}{:} \PY{p}{[}
                        \PY{n}{json}\PY{o}{.}\PY{n}{loads}\PY{p}{(}\PY{n}{documents}\PY{o}{.}\PY{n}{iloc}\PY{p}{[}\PY{n}{x}\PY{p}{]}\PY{o}{.}\PY{n}{to\PYZus{}json}\PY{p}{(}\PY{p}{)}\PY{p}{)} \PY{k}{for} \PY{n}{x} \PY{o+ow}{in} \PY{n+nb}{range}\PY{p}{(}\PY{n}{documents}\PY{o}{.}\PY{n}{shape}\PY{p}{[}\PY{l+m+mi}{0}\PY{p}{]}\PY{p}{)}
                    \PY{p}{]}
                \PY{p}{\PYZcb{}}
                
                \PY{k}{return} \PY{n}{payload}
                
\end{Verbatim}


    \hypertarget{example-data}{%
\subsection{Example data}\label{example-data}}

We've create a very small amount of example data for this walkthrough.
These data are examples of Service Entries entered by our DBA team who
monitor and support databases around NZL and AUS. Each service entry
contains a number of standard fields (TimeEntryNumber, TicketNumber,
Team etc.), the time of the time entry and the notes that the DBA
entered relating to the job. This data has been provided as part of this
walkthrough. Please note that this data has been heavily anonymised and
randomised :)

    \begin{Verbatim}[commandchars=\\\{\}]
{\color{incolor}In [{\color{incolor}2}]:} \PY{n}{example\PYZus{}data} \PY{o}{=} \PY{n}{pd}\PY{o}{.}\PY{n}{read\PYZus{}csv}\PY{p}{(}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{ExampleData.txt}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{n}{encoding} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{ISO\PYZhy{}8859\PYZhy{}1}\PY{l+s+s2}{\PYZdq{}}\PY{p}{)}
        \PY{n}{example\PYZus{}data}\PY{o}{.}\PY{n}{head}\PY{p}{(}\PY{p}{)}
\end{Verbatim}


\begin{Verbatim}[commandchars=\\\{\}]
{\color{outcolor}Out[{\color{outcolor}2}]:}    TimeEntryNumber  TicketNumber  \textbackslash{}
        0           982505       7779668   
        1           982421       7779290   
        2           982414       7730695   
        3           982397       7730695   
        4           982390       7730695   
        
                                               TicketSummary        StaffMember  \textbackslash{}
        0                         DELTANOVA tran log backups        Jake Barber   
        1  Re: Update on EnviroDB Database DELTANOVA Full{\ldots}         Tom Selwyn   
        2               Heartland Foods - End of Year backup      Jenny Hancock   
        3               Heartland Foods - End of Year backup  Catherine Brookes   
        4               Heartland Foods - End of Year backup  Catherine Brookes   
        
               Team BoardName         CustCode  \textbackslash{}
        0  DBA Team   Support   Lithium Energy   
        1  DBA Team   Support   Lithium Energy   
        2  DBA Team   Support  Heartland Foods   
        3  DBA Team   Support  Heartland Foods   
        4  DBA Team   Support  Heartland Foods   
        
                                               TimeEntryNote  HoursActual  \textbackslash{}
        0  Hi Steve,  Can you confirm if there is still a{\ldots}         0.25   
        1  Hi Mark,  It looks like log backups are being {\ldots}         0.25   
        2                                  respond to client         0.00   
        3  Phone call from Jonathan asking if the backup {\ldots}         0.17   
        4  Hi Jonathan  As discussed just now, please see{\ldots}         0.00   
        
          TimeEntryDate  
        0    2018-12-31  
        1    2018-12-31  
        2    2018-12-31  
        3    2018-12-31  
        4    2018-12-31  
\end{Verbatim}
            
    \hypertarget{delete-an-index}{%
\subsection{Delete an index}\label{delete-an-index}}

I already have an index in Azure Search, that I prepared earlier. I am
going to remove this index and reload the data. Removing an index is as
easy as passing a DELETE curl command:

\begin{verbatim}
response,content = http_.request(
    "https://{[service name]}.search.windows.net/indexes/{[index name]}?api-version=2017-11-11", 
    'DELETE',
    headers=headers
)
print(response.status)   # should get a 204 response, if not, read the response content
\end{verbatim}

Note, that the api-version should be the latest verion, recorded here:
https://docs.microsoft.com/en-us/azure/search/search-api-versions

    \begin{Verbatim}[commandchars=\\\{\}]
{\color{incolor}In [{\color{incolor}3}]:} \PY{n}{azuresearch} \PY{o}{=} \PY{n}{AzureSearchDemo}\PY{p}{(}\PY{p}{)}
        \PY{n}{azuresearch}\PY{o}{.}\PY{n}{delete\PYZus{}index}\PY{p}{(}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{time\PYZhy{}entry}\PY{l+s+s2}{\PYZdq{}}\PY{p}{)}
\end{Verbatim}


\begin{Verbatim}[commandchars=\\\{\}]
{\color{outcolor}Out[{\color{outcolor}3}]:} (\{'cache-control': 'no-cache',
          'pragma': 'no-cache',
          'expires': '-1',
          'request-id': '6d42b96d-5bcf-4016-a02d-c3dbdb50190a',
          'elapsed-time': '657',
          'strict-transport-security': 'max-age=15724800; includeSubDomains',
          'date': 'Wed, 02 Jan 2019 21:27:08 GMT',
          'status': '204'\},
         b'')
\end{Verbatim}
            
    \hypertarget{create-an-index}{%
\subsection{Create an index}\label{create-an-index}}

Now that we have a fresh workspace, let's create a new index for our
example data. You can see the schema above, which we will encode as
JSON. There are a couple of points to note:

\begin{itemize}
\tightlist
\item
  when you create an index, the index name must be lowercase.\\
\item
  there must be one (and only one) column which is a unique identifier.
  This column must be a string. We will use the TimeEntryNumber as our
  key column, and just cast this as a string.\\
\item
  take the time to define your datatypes and the search parameters,
  limiting searchability / filterability / facetability etc. to critical
  fields will save you a lot of index space.
\end{itemize}

Note below, that in addition to defining the schema, we have added a
``suggester'' that includes the fields \texttt{StaffMember} and
\texttt{CustCode}. This will allow ``search-as-you-type'', or
autocomplete, functionality. See the documentation:
https://docs.microsoft.com/en-us/rest/api/searchservice/suggesters

Full documentation for creating an index can be found here:
https://docs.microsoft.com/en-us/azure/search/search-create-index-rest-api

    \begin{Verbatim}[commandchars=\\\{\}]
{\color{incolor}In [{\color{incolor}4}]:} \PY{n}{time\PYZus{}entry\PYZus{}schema} \PY{o}{=} \PY{p}{\PYZob{}}
            \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{name}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{time\PYZhy{}entry}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,}
            \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{fields}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{p}{[}
                \PY{p}{\PYZob{}}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{name}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{TimeEntryNumber}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{type}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Edm.String}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{key}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{searchable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{False}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{sortable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{facetable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{False}\PY{p}{\PYZcb{}}\PY{p}{,} 
                \PY{p}{\PYZob{}}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{name}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{TicketNumber}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{type}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Edm.Int32}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{searchable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{False}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{filterable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{sortable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{facetable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{\PYZcb{}}\PY{p}{,}
                \PY{p}{\PYZob{}}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{name}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{TicketSummary}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{type}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Edm.String}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{searchable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{filterable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{False}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{sortable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{False}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{facetable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{False}\PY{p}{\PYZcb{}}\PY{p}{,}
                \PY{p}{\PYZob{}}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{name}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{StaffMember}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{type}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Edm.String}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{searchable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{filterable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{sortable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{facetable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{\PYZcb{}}\PY{p}{,}
                \PY{p}{\PYZob{}}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{name}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Team}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{type}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Edm.String}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{searchable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{False}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{filterable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{sortable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{facetable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{\PYZcb{}}\PY{p}{,}
                \PY{p}{\PYZob{}}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{name}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{BoardName}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{type}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Edm.String}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{searchable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{False}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{filterable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{sortable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{facetable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{\PYZcb{}}\PY{p}{,}
                \PY{p}{\PYZob{}}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{name}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{CustCode}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{type}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Edm.String}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{searchable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{filterable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{sortable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{facetable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{\PYZcb{}}\PY{p}{,}
                \PY{p}{\PYZob{}}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{name}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{TimeEntryNote}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{type}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Edm.String}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{searchable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{filterable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{False}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{sortable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{False}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{facetable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{False}\PY{p}{\PYZcb{}}\PY{p}{,}
                \PY{p}{\PYZob{}}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{name}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{HoursActual}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{type}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Edm.Double}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{searchable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{False}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{filterable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{False}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{sortable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{facetable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{False}\PY{p}{\PYZcb{}}\PY{p}{,}
                \PY{p}{\PYZob{}}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{name}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{TimeEntryDate}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{type}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Edm.String}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{searchable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{False}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{filterable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{sortable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{facetable}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{k+kc}{True}\PY{p}{\PYZcb{}}
            \PY{p}{]}\PY{p}{,}
            \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{suggesters}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{p}{[}\PY{p}{\PYZob{}}
                \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{name}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{sg\PYZhy{}time\PYZhy{}entry}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,}
                \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{searchMode}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{analyzingInfixMatching}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,}
                \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{sourceFields}\PY{l+s+s2}{\PYZdq{}}\PY{p}{:} \PY{p}{[}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{StaffMember}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{CustCode}\PY{l+s+s2}{\PYZdq{}}\PY{p}{]}
            \PY{p}{\PYZcb{}}\PY{p}{]}
        \PY{p}{\PYZcb{}}
        \PY{n}{response}\PY{p}{,} \PY{n}{content} \PY{o}{=} \PY{n}{azuresearch}\PY{o}{.}\PY{n}{create\PYZus{}index}\PY{p}{(}\PY{n}{time\PYZus{}entry\PYZus{}schema}\PY{p}{)}
\end{Verbatim}


    \begin{Verbatim}[commandchars=\\\{\}]
Index,  time-entry, created successfully.

    \end{Verbatim}

    If everything was successful, you should get a 201 response code.
Otherwise, checkout the response content, the error messages are
generally quite informative.

\hypertarget{uploading-new-documents}{%
\subsection{Uploading new documents}\label{uploading-new-documents}}

Microsoft have put a lot of work into streamlining the data ingest
process. If you have a huge amount of data and different formats, you
can load from blob storage in azure. There are all sorts of great
\emph{indexers} which Microsoft have created to parse emails, word
documents, images, PDFs etc..

Of course, you can also push documents up using the rest api. You can
load up to 1000 documents at a time this way, so just take care to batch
this out accordingly. We've written a formating method in our demo class
which will transform a data frame into properly formatted json for this.
You can check out the documentation here:
https://docs.microsoft.com/en-us/azure/search/search-import-data-rest-api

Before we push the data up though, we will cast the TimeEntryNumber as a
string.

    \begin{Verbatim}[commandchars=\\\{\}]
{\color{incolor}In [{\color{incolor}5}]:} \PY{n}{example\PYZus{}data}\PY{p}{[}\PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{TimeEntryNumber}\PY{l+s+s1}{\PYZsq{}}\PY{p}{]} \PY{o}{=} \PY{p}{[}\PY{n+nb}{str}\PY{p}{(}\PY{n}{x}\PY{p}{)} \PY{k}{for} \PY{n}{x} \PY{o+ow}{in} \PY{n}{example\PYZus{}data}\PY{p}{[}\PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{TimeEntryNumber}\PY{l+s+s1}{\PYZsq{}}\PY{p}{]}\PY{p}{]}
        \PY{n}{response}\PY{p}{,} \PY{n}{content} \PY{o}{=} \PY{n}{azuresearch}\PY{o}{.}\PY{n}{upload\PYZus{}documents}\PY{p}{(}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{time\PYZhy{}entry}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{n}{example\PYZus{}data}\PY{p}{,} \PY{n}{docformat} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{dataframe}\PY{l+s+s2}{\PYZdq{}}\PY{p}{)}
        
        \PY{n}{response}\PY{o}{.}\PY{n}{status}
\end{Verbatim}


\begin{Verbatim}[commandchars=\\\{\}]
{\color{outcolor}Out[{\color{outcolor}5}]:} 200
\end{Verbatim}
            
    If successful, you should get a 200 response. Otherwise, read the
response content for possible errors.

\hypertarget{searching}{%
\subsection{Searching}\label{searching}}

Azure Search is built on top of Apache Lucene (actually, I suspect it is
built on top of Elasticsearch). So the search API shares a lot of
similarity with Lucene and Elasticsearch. However, Microsoft have
typically given their API their own flavour. The search documentation
can be found here:
https://docs.microsoft.com/en-us/rest/api/searchservice/search-documents.

NOTE: if you have just loaded these documents, you will need to give
Azure Search \textasciitilde{}1 minute to index them before you start to
search\ldots{}

\textbf{Document count}\\
Let's begin with a simple document count:

    \begin{Verbatim}[commandchars=\\\{\}]
{\color{incolor}In [{\color{incolor}6}]:} \PY{n}{url} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{https://}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{.search.windows.net/indexes/}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{/docs/\PYZdl{}count?api\PYZhy{}version=2017\PYZhy{}11\PYZhy{}11}\PY{l+s+s2}{\PYZdq{}}\PY{o}{.}\PY{n}{format}\PY{p}{(}
            \PY{n}{azuresearch}\PY{o}{.}\PY{n}{service\PYZus{}name}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{time\PYZhy{}entry}\PY{l+s+s2}{\PYZdq{}}
        \PY{p}{)}
        \PY{n}{response}\PY{p}{,} \PY{n}{content} \PY{o}{=} \PY{n}{azuresearch}\PY{o}{.}\PY{n}{conn}\PY{o}{.}\PY{n}{request}\PY{p}{(}\PY{n}{url}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{GET}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{n}{headers} \PY{o}{=} \PY{n}{azuresearch}\PY{o}{.}\PY{n}{header}\PY{p}{)}
        
        \PY{n+nb}{print}\PY{p}{(}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Response status: }\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{n}{response}\PY{o}{.}\PY{n}{status}\PY{p}{)}
        \PY{n+nb}{print}\PY{p}{(}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{JayZ has }\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{ problems, but a 404 aint one...}\PY{l+s+s2}{\PYZdq{}}\PY{o}{.}\PY{n}{format}\PY{p}{(}\PY{n}{content}\PY{p}{)}\PY{p}{)}
\end{Verbatim}


    \begin{Verbatim}[commandchars=\\\{\}]
Response status:  200
JayZ has b'99' problems, but a 404 aint one{\ldots}

    \end{Verbatim}

    \textbf{Simple search}

We can simply search documents that contain terms. For example, we could
search for documents which include ``approval'' and ``Graham Thomas'':

    \begin{Verbatim}[commandchars=\\\{\}]
{\color{incolor}In [{\color{incolor}7}]:} \PY{n}{params} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{graham+thomas+approval}\PY{l+s+s2}{\PYZdq{}}
        \PY{n}{url} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{https://}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{.search.windows.net/indexes/}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{/docs?api\PYZhy{}version=2017\PYZhy{}11\PYZhy{}11\PYZam{}search=}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{\PYZdq{}}\PY{o}{.}\PY{n}{format}\PY{p}{(}
            \PY{n}{azuresearch}\PY{o}{.}\PY{n}{service\PYZus{}name}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{time\PYZhy{}entry}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{n}{params}
        \PY{p}{)}
        \PY{n}{response}\PY{p}{,} \PY{n}{content} \PY{o}{=} \PY{n}{azuresearch}\PY{o}{.}\PY{n}{conn}\PY{o}{.}\PY{n}{request}\PY{p}{(}\PY{n}{url}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{GET}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{n}{headers} \PY{o}{=} \PY{n}{azuresearch}\PY{o}{.}\PY{n}{header}\PY{p}{)}
        
        \PY{n}{documents} \PY{o}{=} \PY{n}{json}\PY{o}{.}\PY{n}{loads}\PY{p}{(}\PY{n}{content}\PY{p}{)}
        \PY{n+nb}{print}\PY{p}{(}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Returned }\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{ documents}\PY{l+s+s2}{\PYZdq{}}\PY{o}{.}\PY{n}{format}\PY{p}{(}\PY{n+nb}{len}\PY{p}{(}\PY{n}{documents}\PY{p}{[}\PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{value}\PY{l+s+s1}{\PYZsq{}}\PY{p}{]}\PY{p}{)}\PY{p}{)}\PY{p}{)}
        \PY{n+nb}{print}\PY{p}{(}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Top hit, score: }\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+se}{\PYZbs{}n}\PY{l+s+s2}{\PYZdq{}}\PY{o}{.}\PY{n}{format}\PY{p}{(}\PY{n}{documents}\PY{p}{[}\PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{value}\PY{l+s+s1}{\PYZsq{}}\PY{p}{]}\PY{p}{[}\PY{l+m+mi}{0}\PY{p}{]}\PY{p}{[}\PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{@search.score}\PY{l+s+s1}{\PYZsq{}}\PY{p}{]}\PY{p}{)}\PY{p}{)}
        \PY{n+nb}{print}\PY{p}{(}\PY{n}{documents}\PY{p}{[}\PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{value}\PY{l+s+s1}{\PYZsq{}}\PY{p}{]}\PY{p}{[}\PY{l+m+mi}{0}\PY{p}{]}\PY{p}{)}
\end{Verbatim}


    \begin{Verbatim}[commandchars=\\\{\}]
Returned 15 documents
Top hit, score: 1.2124215

\{'@search.score': 1.2124215, 'TimeEntryNumber': '979137', 'TicketNumber': 7757068, 'TicketSummary': 'FW: Change Request CHG000917457 Approval Request', 'StaffMember': 'Graham Thomas', 'Team': 'DBA Team', 'BoardName': 'Support', 'CustCode': 'Lithium Energy', 'TimeEntryNote': 'Informational only I believe, although quite lite on actual details of the proposed actions to be taken.', 'HoursActual': 0.25, 'TimeEntryDate': '2018-12-18'\}

    \end{Verbatim}

    Azure's rest api uses Lucene's Simple Query Syntax. Even the simple
query syntax provides a reasonably rish set of operators (AND, OR, NOT,
wildcards, precedence). Check out the documentation:
https://docs.microsoft.com/en-us/rest/api/searchservice/simple-query-syntax-in-azure-search

\textbf{Suggestions}

we set up two ``suggester'' fields on \texttt{StaffMember} and
\texttt{CustCode} when we created this index. Let's see these in action.
There are three staff members whose names begin with "JAS*" in our
example data, let's find them.

We can do this with a simple wildcard:

    \begin{Verbatim}[commandchars=\\\{\}]
{\color{incolor}In [{\color{incolor}8}]:} \PY{n}{params} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Jas*}\PY{l+s+s2}{\PYZdq{}}
        \PY{n}{url} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{https://}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{.search.windows.net/indexes/}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{/docs?api\PYZhy{}version=2017\PYZhy{}11\PYZhy{}11\PYZam{}search=}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{\PYZdq{}}\PY{o}{.}\PY{n}{format}\PY{p}{(}
            \PY{n}{azuresearch}\PY{o}{.}\PY{n}{service\PYZus{}name}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{time\PYZhy{}entry}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{n}{params}
        \PY{p}{)}
        \PY{n}{response}\PY{p}{,} \PY{n}{content} \PY{o}{=} \PY{n}{azuresearch}\PY{o}{.}\PY{n}{conn}\PY{o}{.}\PY{n}{request}\PY{p}{(}\PY{n}{url}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{GET}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{n}{headers} \PY{o}{=} \PY{n}{azuresearch}\PY{o}{.}\PY{n}{header}\PY{p}{)}
        
        \PY{n}{documents} \PY{o}{=} \PY{n}{json}\PY{o}{.}\PY{n}{loads}\PY{p}{(}\PY{n}{content}\PY{p}{)}
        \PY{n+nb}{print}\PY{p}{(}\PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{Returned }\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{ documents}\PY{l+s+s2}{\PYZdq{}}\PY{o}{.}\PY{n}{format}\PY{p}{(}\PY{n+nb}{len}\PY{p}{(}\PY{n}{documents}\PY{p}{[}\PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{value}\PY{l+s+s1}{\PYZsq{}}\PY{p}{]}\PY{p}{)}\PY{p}{)}\PY{p}{)}
        
        \PY{c+c1}{\PYZsh{} gather unique StaffMembers}
        \PY{n+nb}{set}\PY{p}{(}\PY{n}{hit}\PY{p}{[}\PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{StaffMember}\PY{l+s+s1}{\PYZsq{}}\PY{p}{]} \PY{k}{for} \PY{n}{hit} \PY{o+ow}{in} \PY{n}{documents}\PY{p}{[}\PY{l+s+s1}{\PYZsq{}}\PY{l+s+s1}{value}\PY{l+s+s1}{\PYZsq{}}\PY{p}{]}\PY{p}{)}
\end{Verbatim}


    \begin{Verbatim}[commandchars=\\\{\}]
Returned 9 documents

    \end{Verbatim}

\begin{Verbatim}[commandchars=\\\{\}]
{\color{outcolor}Out[{\color{outcolor}8}]:} \{'Jasmine Padhiyar', 'Jason Banwright', 'Jason Fellbourne'\}
\end{Verbatim}
            
    But, it makes more sense to use the suggester that we created\ldots{}
The search query is a little uglier, but I am sure there is a good way
to do this if you actually know what you are doing :) lol. The key
points are:

\begin{itemize}
\tightlist
\item
  we are \texttt{search}ing for \texttt{jas}\\
\item
  in the \texttt{suggester}, \texttt{sg-time-entry}\\
\item
  and returning the fields \texttt{StaffMember}\\
\item
  notice the results also return the unique key for matching documents\\
\item
  the top 5 hits are returned by default
\end{itemize}

    \begin{Verbatim}[commandchars=\\\{\}]
{\color{incolor}In [{\color{incolor}9}]:} \PY{n}{params} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{search=jas\PYZam{}suggesterName=sg\PYZhy{}time\PYZhy{}entry\PYZam{}select=StaffMember}\PY{l+s+s2}{\PYZdq{}}
        \PY{n}{url} \PY{o}{=} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{https://}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{.search.windows.net/indexes/}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{/docs/suggest?api\PYZhy{}version=2017\PYZhy{}11\PYZhy{}11\PYZam{}}\PY{l+s+si}{\PYZob{}\PYZcb{}}\PY{l+s+s2}{\PYZdq{}}\PY{o}{.}\PY{n}{format}\PY{p}{(}
            \PY{n}{azuresearch}\PY{o}{.}\PY{n}{service\PYZus{}name}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{time\PYZhy{}entry}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{n}{params}
        \PY{p}{)}
        \PY{n}{response}\PY{p}{,} \PY{n}{content} \PY{o}{=} \PY{n}{azuresearch}\PY{o}{.}\PY{n}{conn}\PY{o}{.}\PY{n}{request}\PY{p}{(}\PY{n}{url}\PY{p}{,} \PY{l+s+s2}{\PYZdq{}}\PY{l+s+s2}{GET}\PY{l+s+s2}{\PYZdq{}}\PY{p}{,} \PY{n}{headers} \PY{o}{=} \PY{n}{azuresearch}\PY{o}{.}\PY{n}{header}\PY{p}{)}
        
        \PY{n}{documents} \PY{o}{=} \PY{n}{json}\PY{o}{.}\PY{n}{loads}\PY{p}{(}\PY{n}{content}\PY{p}{)}
        \PY{n}{documents}
\end{Verbatim}


\begin{Verbatim}[commandchars=\\\{\}]
{\color{outcolor}Out[{\color{outcolor}9}]:} \{'@odata.context': "https://nick-search-service.search.windows.net/indexes('time-entry')/\$metadata\#docs(*)",
         'value': [\{'@search.text': 'Jason Banwright', 'TimeEntryNumber': '982279'\},
          \{'@search.text': 'Jason Fellbourne', 'TimeEntryNumber': '982266'\},
          \{'@search.text': 'Jasmine Padhiyar', 'TimeEntryNumber': '982231'\},
          \{'@search.text': 'Jasmine Padhiyar', 'TimeEntryNumber': '982209'\},
          \{'@search.text': 'Jason Fellbourne', 'TimeEntryNumber': '982239'\}]\}
\end{Verbatim}
            
    \hypertarget{other-features}{%
\subsection{Other Features}\label{other-features}}

Hopefully, this notebook is enough to get you up and running\ldots{} but
Azure Search has a bunch of other interesting features. Check out:

\begin{itemize}
\tightlist
\item
  Autocomplete :
  https://docs.microsoft.com/en-us/rest/api/searchservice/autocomplete\\
\item
  Lookup document (which retrieves a specified document, for example
  when a user clicks on a hyperlink):
  https://docs.microsoft.com/en-us/rest/api/searchservice/lookup-document\\
\item
  Synonym support:
  https://docs.microsoft.com/en-us/rest/api/searchservice/synonym-map-operations\\
\item
  Spatial support: Azure search has a geography data type, which can be
  used to support spatial applications

  \begin{itemize}
  \tightlist
  \item
    \href{https://stackoverflow.com/questions/44806755/search-azure-search-index-for-documents-within-x-km-of-the-reference-point-where}{SO
    has a nice code snippet for geospatial search}\\
  \item
    \href{https://github.com/Huachao/azure-content/blob/master/articles/search/search-create-geospatial.md}{Microsoft
    have a GitHub repo with a geo-search walkthrough}
  \end{itemize}
\end{itemize}


    % Add a bibliography block to the postdoc
    
    
    
    \end{document}
